unit MDIMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ToolWin, ImgList, ExtCtrls, StdCtrls, ButtonGroup,
  CategoryButtons, ActnList, MiTeC_ButtonGroup, MiTeC_MDIButtonGroup;

type
  TfrmMain = class(TForm)
    MainMenu: TMainMenu;
    ImageList: TImageList;
    sd: TSaveDialog;
    od: TOpenDialog;
    mmFile: TMenuItem;
    mmWin: TMenuItem;
    mmHelp: TMenuItem;
    mmOpen: TMenuItem;
    mmReopen: TMenuItem;
    mmSave: TMenuItem;
    mmSaveAs: TMenuItem;
    mmClose: TMenuItem;
    mmCloseAll: TMenuItem;
    N1: TMenuItem;
    mmExit: TMenuItem;
    mmMinAll: TMenuItem;
    mmAbout: TMenuItem;
    mmNew: TMenuItem;
    mmCascade: TMenuItem;
    mmTileHor: TMenuItem;
    mmTileVer: TMenuItem;
    pd: TPrintDialog;
    psd: TPrinterSetupDialog;
    N2: TMenuItem;
    mmPrintSetup: TMenuItem;
    mmPrint: TMenuItem;
    ControlBar: TControlBar;
    ToolBar: TToolBar;
    sbNew: TToolButton;
    sbOpen: TToolButton;
    sbSave: TToolButton;
    sbPrint: TToolButton;
    ToolButton8: TToolButton;
    sbClose: TToolButton;
    sbCascade: TToolButton;
    sbTileHor: TToolButton;
    sbTileVer: TToolButton;
    ToolButton4: TToolButton;
    sbAbout: TToolButton;
    sbExit: TToolButton;
    sb: TStatusBar;
    mmView: TMenuItem;
    mmToolbar: TMenuItem;
    mmWindowBar: TMenuItem;
    mmStatusBar: TMenuItem;
    mdibg: TMDIButtonGroup;
    ilWin: TImageList;
    WinBarMenu: TPopupMenu;
    pmTitle: TMenuItem;
    N5: TMenuItem;
    pmRestore: TMenuItem;
    pmMinimize: TMenuItem;
    pmMaximize: TMenuItem;
    N3: TMenuItem;
    pmMinimizeAll: TMenuItem;
    pmCloseAll: TMenuItem;
    N4: TMenuItem;
    pmClose: TMenuItem;
    WinActionList: TActionList;
    wacTitle: TAction;
    wacRestore: TAction;
    wacMinimize: TAction;
    wacMaximize: TAction;
    wacMinAll: TAction;
    wacCloseAll: TAction;
    wacClose: TAction;
    TrackBar1: TTrackBar;
    ColorBox1: TColorBox;
    ColorBox2: TColorBox;
    ColorBox3: TColorBox;
    N6: TMenuItem;
    wacAutoSize: TAction;
    AutoSize1: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cmCloseAll(Sender: TObject);
    procedure cmOpen(Sender: TObject);
    procedure cmClose(Sender: TObject);
    procedure cmExit(Sender: TObject);
    procedure cmMinAll(Sender: TObject);
    procedure cmNew(Sender: TObject);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure cmCascade(Sender: TObject);
    procedure cmTileHor(Sender: TObject);
    procedure cmTileVer(Sender: TObject);
    procedure cmPrint(Sender: TObject);
    procedure cmPrintSetup(Sender: TObject);
    procedure cmToolbar(Sender: TObject);
    procedure cmWindowBar(Sender: TObject);
    procedure cmStatusBar(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure wacTitleExecute(Sender: TObject);
    procedure wacCloseExecute(Sender: TObject);
    procedure WinBarMenuPopup(Sender: TObject);
    procedure wacStateExecute(Sender: TObject);
    procedure wacMinAllExecute(Sender: TObject);
    procedure wacCloseAllExecute(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure ColorBox2Change(Sender: TObject);
    procedure ColorBox3Change(Sender: TObject);
    procedure wacAutoSizeExecute(Sender: TObject);
  private
  public
    procedure OpenFile(const fn :string);
  end;

var
  frmMain: TfrmMain;

implementation
uses MDIChild;

{$R *.DFM}

procedure TfrmMain.OpenFile;
var
  child :tfrmchild;
begin
  if fileexists(fn) then begin
    child:=tfrmchild.create(self);
    child.filename:=fn;
    mdibg.AddButton(child,10,'');
  end else
    MessageDlg('Cannot open file '+fn+'.',mtError,[mbOK],0);
end;

procedure TfrmMain.TrackBar1Change(Sender: TObject);
begin
  mdibg.ButtonWidth:=Trackbar1.Position;
end;

procedure TfrmMain.wacAutoSizeExecute(Sender: TObject);
begin
  mdibg.AutoSize:=TAction(Sender).Checked;
end;

procedure TfrmMain.wacCloseAllExecute(Sender: TObject);
begin
  mdibg.CloseAll;
end;

procedure TfrmMain.wacCloseExecute(Sender: TObject);
begin
  mdibg.MDIChildren[mdibg.HotButtonIndex].Close;
end;

procedure TfrmMain.wacStateExecute(Sender: TObject);
begin
  case TComponent(Sender).Tag of
    0: mdibg.MDIChildren[mdibg.HotButtonIndex].WindowState:=wsNormal;
    1: mdibg.MDIChildren[mdibg.HotButtonIndex].WindowState:=wsMinimized;
    2: mdibg.MDIChildren[mdibg.HotButtonIndex].WindowState:=wsMaximized;
  end;
end;

procedure TfrmMain.wacMinAllExecute(Sender: TObject);
begin
  mdibg.MinimizeAll;
end;

procedure TfrmMain.wacTitleExecute(Sender: TObject);
begin
  with mdibg.MDIChildren[mdibg.HotButtonIndex] do begin
    Setfocus;
    BringToFront;
  end;
end;

procedure TfrmMain.WinBarMenuPopup(Sender: TObject);
begin
  if mdibg.HotButtonIndex>-1 then
    wacTitle.Caption:=mdibg.MDIChildren[mdibg.HotButtonIndex].Caption
  else
    wacTitle.Caption:='<none>';
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  cmcloseall(sender);
end;

procedure TfrmMain.cmCloseAll(Sender: TObject);
begin
  mdibg.CloseAll;
end;

procedure TfrmMain.cmClose(Sender: TObject);
begin
  if mdichildcount>0 then
    activemdichild.close;
end;

procedure TfrmMain.cmExit(Sender: TObject);
begin
  close;
end;

procedure TfrmMain.cmMinAll(Sender: TObject);
begin
  mdibg.MinimizeAll;
end;

procedure TfrmMain.cmNew(Sender: TObject);
var
  child :tfrmchild;
begin
  child:=tfrmchild.create(self);
  child.caption:='Child #'+inttostr(frmmain.mdichildcount);
  mdibg.AddButton(child,10,child.caption);
end;

procedure TfrmMain.AppIdle(Sender: TObject; var Done: Boolean);
begin
  mmsave.enabled:=(mdichildcount>0) {and tfrmchild(activemdichild).modified};
  mmsaveas.enabled:=mdichildcount>0;
  mmclose.enabled:=mdichildcount>0;
  mmcloseall.enabled:=mdichildcount>0;
  mmminall.enabled:=mdichildcount>0;
  mmcascade.enabled:=mdichildcount>0;
  mmtilehor.enabled:=mdichildcount>0;
  mmtilever.enabled:=mdichildcount>0;
  mmprint.enabled:=mdichildcount>0;
  mmtoolbar.checked:=toolbar.visible;
  mmwindowbar.checked:=mdibg.visible;
  mmstatusbar.checked:=sb.visible;
  sbsave.enabled:=mmsave.enabled;
  sbclose.enabled:=mmclose.enabled;
  sbcascade.enabled:=mmcascade.enabled;
  sbtilehor.enabled:=mmtilehor.enabled;
  sbtilever.enabled:=mmtilever.enabled;
  sbprint.enabled:=mmprint.enabled;

  wacTitle.Enabled:=mdibg.HotButtonIndex<>-1;
  wacMinimize.Enabled:=mdibg.HotButtonIndex<>-1;
  wacMaximize.Enabled:=mdibg.HotButtonIndex<>-1;
  wacClose.Enabled:=mdibg.HotButtonIndex<>-1;
  wacRestore.Enabled:=mdibg.HotButtonIndex<>-1;
end;

procedure TfrmMain.cmCascade(Sender: TObject);
begin
  cascade;
end;

procedure TfrmMain.cmTileHor(Sender: TObject);
begin
  tilemode:=tbhorizontal;
  tile;
end;

procedure TfrmMain.cmTileVer(Sender: TObject);
begin
  tilemode:=tbvertical;
  tile;
end;

procedure TfrmMain.cmPrint(Sender: TObject);
begin
  if mdichildcount>0 then
    with tfrmchild(activemdichild) do begin
      if pd.execute then begin

      end;
    end;
end;

procedure TfrmMain.cmPrintSetup(Sender: TObject);
begin
  psd.execute;
end;

procedure TfrmMain.cmToolbar(Sender: TObject);
begin
  toolbar.visible:=not toolbar.visible;
end;

procedure TfrmMain.cmWindowBar(Sender: TObject);
begin
  mdibg.visible:=not mdibg.visible;
end;

procedure TfrmMain.ColorBox1Change(Sender: TObject);
begin
  mdibg.RegularButtonColor:=ColorBox1.Selected;
end;

procedure TfrmMain.ColorBox2Change(Sender: TObject);
begin
  mdibg.SelectedButtonColor:=ColorBox2.Selected;
end;

procedure TfrmMain.ColorBox3Change(Sender: TObject);
begin
  mdibg.HotButtonColor:=ColorBox3.Selected;
end;

procedure TfrmMain.cmStatusBar(Sender: TObject);
begin
  sb.visible:=not sb.visible;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  if mdibg.Parent is TControlbar then
    mdibg.Width:=Width;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  application.OnIdle:=appidle;
end;

procedure TfrmMain.cmOpen(Sender: TObject);
begin
  if od.execute then
    openfile(od.filename);
end;

end.
